unit UnitFrmLines;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;


type TNoPaintForm = class(TForm)
    procedure rePaint; override;
    procedure Invalidate; override;
  private
    procedure Paint;
end;
type
  TFrmLines = class(TForm)

  private
    { Private declarations }
    lastP : TPoint;
    originP : TPoint;
    inited : boolean;
    second : boolean;
    forw :thandle;
  protected

  public
    { Public declarations }
    procedure reportPoint(P : TPoint);
    procedure reportMouseButton(down : boolean);
  end;

var
  FrmLines: TFrmLines;

implementation

uses UnitMisc, UnitFrmScratchpad;

{$R *.dfm}


{ NoPaintForm }

procedure TNoPaintForm.Invalidate;
begin
  inherited;

    self.Paint;
end;

procedure TNoPaintForm.Paint;
begin
    canvas.Brush.Style := bsClear;
    canvas.Pen.Style := psClear;

    inherited;
end;

procedure TNoPaintForm.rePaint;
begin
  inherited;
   // self.paint;
end;

{ TFrmLines }

procedure TFrmLines.reportMouseButton(down: boolean);
begin
    if (not down) and self.visible then begin
        self.CLOSE;
        if ThreadAttach(forw) then begin
            SetForegroundWindow(forw);
            ThreadDetach;
        end;    //FrmScratchpad.RemoveSelfFromFocus();

        self.inited := false;
    end;
end;

procedure TFrmLines.reportPoint(P: TPoint);
var s : TShape;
begin


    canvas.Pen.Width := 2;
    canvas.Pen.Color := clWindowText;
    if not inited then begin
        inited := true;
        OriginP := p;
        canvas.MoveTo(width div 2, height div 2);
        second := true;
    end else if second then begin
        self.Top := p.y - (height div 2);
        self.Left := p.X - (width div 2);
        second := false;
        forw := GetForegroundWindow;

        if ThreadAttach(forw) then begin
            self.Show;
            SetForegroundWindow(self.Handle);
            ThreadDetach;
        end;
    end else begin
        if self.visible then begin
            canvas.LineTo(p.x - originP.X + (width div 2), p.Y - originP.y + (height div 2));
        end;
    end;

    lastp := p;

end;

end.
